import config as cf
from heuristic_aux import argmin_f, argmax_f, max_f, hire_car_f, fill_car_f

import numpy as np
import time as tme

def heuristic_f(s_dict, r_dict, arrivals, s_cars_at_node, distance, n_ins):
    tic = tme.perf_counter()
    scenarios = range(cf.nscenario)
    
    a = {i:[arrivals[sc][i].sum() for sc in scenarios] 
                for i in cf.pickup[n_ins]}
    a_max = {i: max(a[i]) for i in cf.pickup[n_ins]}

    a_rem = {i: a_max[i] for i in cf.pickup[n_ins]}
    a_rem_tot = sum(a_rem.values())

    S_H = []
    E = {i: [s for s in s_cars_at_node['Os'+str(i)].keys()]
         for i in cf.pickup[n_ins]}

    q_rem = {s:s_dict[s]['capacity'] for s in s_dict.keys()}
    q_rem_h = 0

    q_r_tot = sum([r_dict[r]['capacity'] for r in r_dict.keys()])

    if len(cf.r_origins[n_ins]) == 1:
        dist_from_origin = {i:distance.iat[cf.r_origins[n_ins][0],i] 
                                for i in cf.pickup[n_ins]}
        s_loc_order = [key for (key,value) in sorted(dist_from_origin.items(),
                                                      key=lambda x:x[1],
                                                      reverse=True)]
    else:
        s_loc_order = cf.pickup[n_ins]
        
    for i in s_loc_order:
        while (a_rem_tot > q_r_tot + q_rem_h
               and len(E[i]) > 0
               and a_rem[i] > 0
               ):
            (E, S_H, q_rem, q_rem_h, 
             a_rem, a_rem_tot) = hire_car_f(i, i, E, S_H, q_rem, q_rem_h,
                                            a_rem, a_rem_tot)
                        
    while (a_rem_tot > q_r_tot + sum([q_rem[s] for s in S_H]) 
           and (sum(len(E[i]) for i in cf.pickup[n_ins])> 0
                or sum(q_rem[s] for s in S_H)>0)
           ):
        i_max_demand = argmax_f(a_rem)

        if sum([q_rem[s] for s in S_H]) > 0:  
            dist_from_i_max = {j: distance.iat[j,i_max_demand] 
                               for j in cf.pickup[n_ins]
                               if sum([q_rem[s] 
                                       for s in S_H
                                       if s_dict[s]['origin']=='Os'+str(j)]
                                      )>0}
            
            i = argmin_f(dist_from_i_max)

            s_h = argmax_f({s:q_rem[s] 
                            for s in S_H
                            if s_dict[s]['origin']=='Os'+str(i)
                            })
            
            (q_rem, q_rem_h, 
             a_rem, a_rem_tot) = fill_car_f(s_h, i_max_demand, q_rem, q_rem_h, 
                                            a_rem, a_rem_tot)
            
        else:
            dist_from_i_max = {j: distance.iat[j,i_max_demand] 
                               for j in cf.pickup[n_ins]
                               if len(E[j])>0}
            i = argmin_f(dist_from_i_max)

            (E, S_H, q_rem, 
             q_rem_h, a_rem, a_rem_tot) = hire_car_f(i, i_max_demand, E, S_H, 
                                                     q_rem, q_rem_h, a_rem, 
                                                     a_rem_tot)
    toc = tme.perf_counter()
    return {s:s_dict[s] for s in S_H}, toc-tic
        
    
    
    
    