import numpy as np

def cars_leave_f(hired_cars, scenarios, total_scenarios, G_o, cars, y):
    leave_origin_zone = [0 for sc in total_scenarios]
    
    for v in hired_cars:
        for sc in scenarios:
            change_pickup_location = 0
            for it, jtt, move in G_o[cars[v]['origin']].edges(data='move'):
                if y[v,it,jtt,sc].x == 1 and move:
                    change_pickup_location = 1
                    break
            leave_origin_zone[sc] += change_pickup_location
    return np.array(leave_origin_zone)

def store_route_f(G_o, cars, v, y, q):
    traversededges = []
    loads = {}
    for it, jtt in G_o[cars[v]['origin']].edges:
        if y[v,it,jtt,0].x==1:
            traversededges.append((it,jtt))
            if type(jtt[0]) == int and q[v,jtt[0],jtt[1],0].x > 0:
                if jtt[0] in loads.keys():
                    loads[jtt[0]][jtt[1]] = q[v,jtt[0],jtt[1],0].x
                else:
                    loads[jtt[0]] = {jtt[1]: q[v,jtt[0],jtt[1],0].x}
    return {'edgelist':traversededges,'loads':loads}
