import config as cf
from vehicle_aux import (read_vehicle_dist_f, vehicle_error_f, 
                         vehicle_at_node_f, vehicle_per_node_f)

import pandas as pd

def vehicle_f(expected_period_demand, n_ins, r_hour_folder):
    if cf.car_spatial_dist == 'fix total and distribution':
        s_cars_per_node = cf.s_cars_per_node
        r_cars_per_node = cf.r_cars_per_node
        
        if len(cf.networks) > 1:
            vehicle_error_f(cf.car_spatial_dist)
    
    elif cf.car_spatial_dist == 'read total and distribution':
        s_cars_per_node = read_vehicle_dist_f(r_hour_folder, 
                                              cf.s_vehicle_dist_file, 
                                              cf.s_origins[n_ins])
        r_cars_per_node = read_vehicle_dist_f(r_hour_folder, 
                                              cf.r_vehicle_dist_file, 
                                              cf.r_origins[n_ins])
    
    else:
        s_cars_spatial_dist = pd.read_csv(cf.s_cars_spatial_dist_file)
        r_cars_spatial_dist = pd.read_csv(cf.r_cars_spatial_dist_file)
        
        if cf.car_spatial_dist == 'fix total, calculate distribution':
            total_s_cars = cf.total_s_cars
            total_r_cars = cf.total_r_cars
            
            if len(cf.networks) > 1:
                vehicle_error_f(cf.car_spatial_dist)
                
        elif cf.car_spatial_dist == 'calculate total cars and distribution':
            s_proportion = cf.vehicledistribution[0]
            r_proportion = cf.vehicledistribution[1] 
    
            total_s_cars = (s_proportion*expected_period_demand
                            /cf.expected_s_capacity*cf.excess_cars_available)
            total_r_cars = (r_proportion*expected_period_demand
                            /cf.expected_r_capacity*cf.excess_cars_available)
        
        s_cars_per_node = vehicle_per_node_f(s_cars_spatial_dist, 
                                             cf.s_origins[n_ins], 
                                             total_s_cars)
        
        r_cars_per_node = vehicle_per_node_f(r_cars_spatial_dist, 
                                             cf.r_origins[n_ins], 
                                             total_r_cars)
        
    if cf.random_s_parameters:
        s_param_list = cf.s_param
        s_prob = cf.s_p
    
    else:
        s_param_list = [(cf.s_cost, cf.s_capacity)]
        s_prob = [1]
    
    s_cars_at_node = vehicle_at_node_f(s_cars_per_node, cf.s_origins[n_ins], 
                                        s_param_list, s_prob, 'Os', 'S')
    
    if cf.random_r_parameters:
        r_param_list = cf.r_param_list
        r_prob = cf.r_p
        
    else:
        r_param_list = [(cf.r_cost, cf.r_capacity)]
        r_prob = [1]
        
    r_cars_at_node = vehicle_at_node_f(r_cars_per_node, cf.r_origins[n_ins], 
                                        r_param_list, r_prob, 'Or', 'R')
    
     
    s_dict = {}
    
    for orig in s_cars_at_node.keys():
        s_dict.update(s_cars_at_node[orig])
    
    r_dict = {}
    for orig in r_cars_at_node.keys():
        r_dict.update(r_cars_at_node[orig])
    
    return(s_dict, r_dict, s_cars_at_node, r_cars_at_node)

